searchData={"items":[{"type":"module","title":"GoogleAds","doc":"Documentation for `GoogleAds`.","ref":"GoogleAds.html"},{"type":"function","title":"GoogleAds.append_lead_conversation/4","doc":"Append Local Services Lead Conversation resources to Local Services Lead resources.\n\nhttps://developers.google.com/google-ads/api/rest/reference/rest/v18/customers.localServices/appendLeadConversation","ref":"GoogleAds.html#append_lead_conversation/4"},{"type":"function","title":"GoogleAds.paginate/1","doc":"Paginates the results of a paginated function.\n\nExample:\n\n    GoogleAds.paginate(fn pagination_options ->\n      GoogleAds.search(developer_token, token, customer_id, request_body, pagination_options)\n    end)","ref":"GoogleAds.html#paginate/1"},{"type":"function","title":"GoogleAds.search/4","doc":"Returns all rows that match the search query.\n\nhttps://developers.google.com/google-ads/api/rest/reference/rest/v18/customers.googleAds/search","ref":"GoogleAds.html#search/4"},{"type":"function","title":"GoogleAds.search/5","doc":"","ref":"GoogleAds.html#search/5"},{"type":"type","title":"GoogleAds.access_token/0","doc":"","ref":"GoogleAds.html#t:access_token/0"},{"type":"type","title":"GoogleAds.append_lead_conversation_response/0","doc":"","ref":"GoogleAds.html#t:append_lead_conversation_response/0"},{"type":"type","title":"GoogleAds.customer_id/0","doc":"","ref":"GoogleAds.html#t:customer_id/0"},{"type":"type","title":"GoogleAds.developer_token/0","doc":"","ref":"GoogleAds.html#t:developer_token/0"},{"type":"type","title":"GoogleAds.error_response/0","doc":"","ref":"GoogleAds.html#t:error_response/0"},{"type":"type","title":"GoogleAds.paginated_function/0","doc":"","ref":"GoogleAds.html#t:paginated_function/0"},{"type":"type","title":"GoogleAds.pagination_options/0","doc":"","ref":"GoogleAds.html#t:pagination_options/0"},{"type":"type","title":"GoogleAds.pagination_result/0","doc":"","ref":"GoogleAds.html#t:pagination_result/0"},{"type":"type","title":"GoogleAds.request_body/0","doc":"","ref":"GoogleAds.html#t:request_body/0"},{"type":"type","title":"GoogleAds.search_response/0","doc":"","ref":"GoogleAds.html#t:search_response/0"},{"type":"behaviour","title":"GoogleAds.Adapter","doc":"This module is the Adapter that defines the interface for the Google Ads provider.","ref":"GoogleAds.Adapter.html"},{"type":"callback","title":"GoogleAds.Adapter.append_lead_conversation/4","doc":"","ref":"GoogleAds.Adapter.html#c:append_lead_conversation/4"},{"type":"callback","title":"GoogleAds.Adapter.search/4","doc":"","ref":"GoogleAds.Adapter.html#c:search/4"},{"type":"callback","title":"GoogleAds.Adapter.search/5","doc":"","ref":"GoogleAds.Adapter.html#c:search/5"},{"type":"module","title":"GoogleAds.Application","doc":"This module is responsible for starting the Google Ads supervision tree.","ref":"GoogleAds.Application.html"},{"type":"module","title":"GoogleAds.Client","doc":"This module is responsible for issuing requests to the Google Ads API.\n\nGoogle advises to trace the request-id header\nhttps://developers.google.com/google-ads/api/docs/concepts/call-structure#request-id\n\nWith the request id, we can create a correlation between the request and the response\nreturned by the Google Ads API. This is useful when working with Google Ads support.","ref":"GoogleAds.Client.html"},{"type":"module","title":"GoogleAds.Dummy","doc":"Dummy implementation of the Google Ads provider.","ref":"GoogleAds.Dummy.html"},{"type":"module","title":"GoogleAds.Telemetry.QueryResourceConsumption","doc":"Telemetry handler for computing the query resource consumption spent on Google Ads API requests.","ref":"GoogleAds.Telemetry.QueryResourceConsumption.html"},{"type":"function","title":"GoogleAds.Telemetry.QueryResourceConsumption.handle_event/4","doc":"","ref":"GoogleAds.Telemetry.QueryResourceConsumption.html#handle_event/4"},{"type":"function","title":"GoogleAds.Telemetry.QueryResourceConsumption.setup/0","doc":"","ref":"GoogleAds.Telemetry.QueryResourceConsumption.html#setup/0"},{"type":"module","title":"GoogleAds.Token","doc":"The struct that represents the Google Ads Token.","ref":"GoogleAds.Token.html"},{"type":"function","title":"GoogleAds.Token.build/1","doc":"","ref":"GoogleAds.Token.html#build/1"},{"type":"type","title":"GoogleAds.Token.t/0","doc":"","ref":"GoogleAds.Token.html#t:t/0"},{"type":"module","title":"GoogleAds.TokenCache","doc":"Cache instance for Google Ads tokens.","ref":"GoogleAds.TokenCache.html"},{"type":"function","title":"GoogleAds.TokenCache.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GoogleAds.TokenCache.html#child_spec/1"},{"type":"function","title":"GoogleAds.TokenCache.get/1","doc":"","ref":"GoogleAds.TokenCache.html#get/1"},{"type":"function","title":"GoogleAds.TokenCache.insert/3","doc":"","ref":"GoogleAds.TokenCache.html#insert/3"},{"type":"function","title":"GoogleAds.TokenCache.start_link/1","doc":"","ref":"GoogleAds.TokenCache.html#start_link/1"},{"type":"type","title":"GoogleAds.TokenCache.prismatic_ref/0","doc":"","ref":"GoogleAds.TokenCache.html#t:prismatic_ref/0"},{"type":"extras","title":"GoogleAds","doc":"# GoogleAds\n\nGoogle Ads SDK.","ref":"readme.html"},{"type":"extras","title":"Installation - GoogleAds","doc":"The package can be installed by adding `google_ads` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:google_ads, \"~> 0.1.0\"}\n  ]\nend\n```\n\nThe docs can be found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Usage - GoogleAds","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Set the config - GoogleAds","doc":"```elixir\nconfig :google_ads,\n  client: GoogleAds.Client, # Or GoogleAds.Dummy for dev enviromment\n\n```\n\nOptionally set the API version, defaults to `18`:\n\n```elixir\nconfig :google_ads,\n  api_version: \"17\"\n```\n\nOptionally set the retry config:\n\n```elixir\nconfig :google_ads,\n  client: GoogleAds.Client, # Or GoogleAds.Dummy for dev enviromment\n  retry_config: [\n    delay: \"1000\",\n    max_retries: \"10\",\n    max_delay: \"2000\"\n  ]\n```","ref":"readme.html#set-the-config"},{"type":"extras","title":"Search - GoogleAds","doc":"Returns all rows that match the search query.\n\nExample:\n\n```elixir\nrequest_body = %{\n  \"query\" => \"SELECT * FROM customer_client WHERE id = 123\"\n}\n\nGoogleAds.search(developer_token, access_token, customer_id, request_body)\n```","ref":"readme.html#search"},{"type":"extras","title":"Append lead conversation - GoogleAds","doc":"Append Local Services Lead Conversation resources to Local Services Lead resources.\n\nExample:\n\n```elixir\nrequest_body = %{\n  \"conversations\" => [\n    %{\n      \"localServicesLead\" => \"customers/123/localServicesLeads/456\",\n      \"text\" => \"text\"\n    }\n  ]\n}\n\nGoogleAds.append_lead_conversation(developer_token, access_token, customer_id, request_body)\n```","ref":"readme.html#append-lead-conversation"},{"type":"extras","title":"Pagination - GoogleAds","doc":"Paginates the results of a paginated function.\n\nExample:\n\n```elixir\nGoogleAds.paginate(fn pagination_options ->\n  GoogleAds.search(developer_token, access_token, customer_id, request_body, pagination_options)\nend)\n```","ref":"readme.html#pagination"},{"type":"extras","title":"Telemetry - GoogleAds","doc":"You can attach Google Ads telemetry to your app.","ref":"readme.html#telemetry"},{"type":"extras","title":"QueryResourceConsumption - GoogleAds","doc":"Setup\n\n```elixir\nGoogleAds.Telemetry.QueryResourceConsumption.setup()\n```\n\nIt will emit the following event:\n\n \n   [:google_ads, :query_resource] \n\n**Measurements**:\n\n- consumption: `integer()`\n\n**Metadata**:\n\n- metadata: `String.t()`\n- query: `String.t()`","ref":"readme.html#queryresourceconsumption"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n## [0.1.6] - 2024-12-12\n\n  - Fix `QueryResourceConsumption` when the request body keys are string\n\n## [0.1.5] - 2024-12-12\n\n  - Add `:telemetry` dependency\n\n## [0.1.4] - 2024-12-12\n\n  - Replace `metadata` by `customer_id` on telemetry metadata\n  - Setup `GoogleAds.Telemetry.QueryResourceConsumption` telemetry on init\n\n## [0.1.3] - 2024-12-12\n\n  - Add provider to client telemetry metadata\n\n## [0.1.2] - 2024-12-11\n\n  - Fix library configuration\n\n## [0.1.1] - 2024-12-11\n\n  - Make API version configurable\n\n## [0.1.0] - 2024-12-10\n\n  - Initial version","ref":"changelog.html"},{"type":"extras","title":"License","doc":"Copyright 2023 Hatch\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}